#Ovládání DC motoru 0-100% (5-95%), jeden směr.
import cv2
import numpy as np
import tkinter as tk
import pygame
import time
from PIL import ImageTk, Image

frekvence = 400         # nosná frerkvence pro DC
duration = 1/frekvence  # délka samplu v s
sample_rate = 40000     # samplovací frekvence - 100samplů/periodu       
mL0 = 200               # pomocné, pamatují si předešlou hodnotu, hodnota 200 provede inicializaci
mR0 = 100
dmL = 0			# uživatelská korekce posunu audio kanálů = korekce USB_C převodníku
dmR = 0			# korekce +-100%
signalLR = np.int16(np.zeros((int(sample_rate*duration) * 2)))

#určeno pouze pro demostraci funkčnosti
casOld = time.time()
citac = 0 
delta = 50

# inicializace
# nastavení parametrů mixéru: vzorkovací frekvence/ počet kanálů/ povolení změn/ 
# defaltně 16b hodnota -16b = +-32000
pygame.mixer.pre_init(frequency=sample_rate, channels=2, allowedchanges=1)
pygame.init()

# Vytvoření zvukového objektu pomocí knihovny pygame
sound = pygame.mixer.Sound(signalLR.tobytes()) # předávání hodnot po Bytu
sound.play(-1) # -1 znamená nekonečné opakování

# výpočet tvaru signálu a odeslání na výstup, mL a mR v rozsahu 0..100%, (duty = 0..95)
def motory(mL, mR):
    global signalLR, mL0, mR0, dmL,dmR, sound
    mL, mR = int((mL+dmL)/1), int((mR+dmR)/1) #změněno na rozsah 0..100
    if mL<5: mL=5 #??? je potřeba?
    if mL>95: mL=95 #ořez na 5..95%, zachování AC pro kondenzátor
    if mR<5: mR=5
    if mR>95: mR=95
    if (mL != mL0) or (mR != mR0):
        # plnění v násobcích 0.025ms = 25us (mikrosekund)
        # 0 - stojí   95 - jede  - !!!CELÉ číslo
        dutyL = int(mL)
        dutyR = int(mR)
        #print(dutyL,dutyR)
        #vygenerování L-kanálu
        signalLR[0:(2*dutyL):2]=-32767
        signalLR[(2*dutyL)::2]=32767 #??? nestačila by 0?
        #vygenerování R-kanálu
        signalLR[1:(2*dutyR+1):2]=-32767
        signalLR[(2*dutyR+1)::2]=32767

        sound.stop()
        sound = pygame.mixer.Sound(signalLR.tobytes()) # předávání hodnot po Bytu
        sound.play(-1)  # -1 znamená nekonečné opakování

        mL0, mR0 = mL, mR
                
# hlavní program

motory(citac,citac) #rozsah 0..100% (5..95)

while True:
        
    #POUZE pro demostraci funkčnosti
    if (time.time()-casOld) > 2:
        casOld = time.time()
        citac = citac + 1
        if citac > 6:
            citac = 1            
        if citac%2 < 1:
            motory(0,0)
        if citac == 1:
            motory(60,60)
        if citac == 3:
            motory(0,60)
        if citac == 5:
            motory(60,0)
        print(citac)